from tile import Tile

wares = {
	"people": 0,
	"food": 0,
	"coal": 0, 
	"iron": 0,
	"steel": 0,
	"oil": 0,
	"wood": 0,
	"gasoline": 0,
	"guns": 0,
	"cars": 0,
	}

def cost(obj):
	return obj[1].price + obj[2]

#class Industry(Object):
class Industry(Tile):
	def __init__(self, position):
		Tile.__init__(self, position)
		self.kind = "Industry"
		self.position = position
		self.isIndustry = True
		self.isBuilding = True
		
		self.owner = None
		self.buyCost = 0
		self.purchaseValue = 100 #how much money a resource gives to the player
		
		self.targetIndustry = None
		self.distanceToTarget = 0
		
		self.incoming = wares.copy()
		self.producedResource = None
		#self.production = wares.copy()
		self.requirements = {}
		#self.available = wares.copy()
		#self.prices = wares.copy()
		self.sub_init()
		
	def sub_init(self):
		class AbstractClassException(Exception): pass
		raise AbstractClassException("You can't build an industry without purpose.")
	
	
########################################
########################################
class NaturalResourceIndustry(Industry):
	def __init__(self, position):
		Industry.__init__(self, position)
		self.purchaseValue = 500
		self.buyCost = 500
		self.sub_init()

class Refinery(Industry):
	def __init__(self, position):
		Industry.__init__(self, position)
		self.buyCost = 7500
		self.purchaseValue = 750
		self.sub_init()

class Factory(Industry):
	def __init__(self, position):
		Industry.__init__(self, position)
		self.buyCost = 15000
		self.purchaseValue = 1500
		self.sub_init()
		
		
########################################
########################################

class CoalMine(NaturalResourceIndustry):
	def sub_init(self):
		self.kind = "Coal mine"
		self.producedResource = "coal"

class IronMine(NaturalResourceIndustry):
	def sub_init(self):
		self.kind = "Iron mine"
		self.producedResource = "iron"

class Forest(NaturalResourceIndustry):
	def sub_init(self):
		self.kind = "Forest"
		self.producedResource = "logs"

class Farm(NaturalResourceIndustry):
	def sub_init(self):
		self.kind = "Farm"
		self.producedResource = "food"
		self.requirements["tools"] = 10
		self.requirements["coal"] = 10

"""
class WoodMill(Industry):
	def sub_init(self):
		self.kind = "Wood mill"
		self.buyCost = 5000
		self.purchaseValue = 500
		self.producedResource = "wood"
		self.requirements["people"] = 80
		self.requirements["coal"] = 100
		self.requirements["logs"] = 400
"""

########################################
########################################
		
class SteelMill(Refinery):
	def sub_init(self):
		self.kind = "Steel mill"
		self.producedResource = "steel"
		self.requirements["coal"] = 10
		self.requirements["iron"] = 10




########################################
########################################


class ToolFactory(Factory):
	def sub_init(self):
		self.kind = "Tool factory"
		self.producedResource = "tools"
		self.requirements["steel"] = 4

class City(Industry):
	def sub_init(self):
		self.kind = "City"
		self.size = 1
		self.producedResource = "people"
		self.requirements["food"] = 10

		
		
		