import random
from tile import Tile, GrassGround, DirtGrassGround, TreeGrassGround

X, Y = 0, 1

class TileMapRangeException(Exception): pass

class TileMap:
	def __init__(self, width, height):
		tileClasses = [GrassGround, GrassGround, DirtGrassGround, DirtGrassGround, TreeGrassGround]
		self.tilemap = [[random.choice(tileClasses)((j,i))  for i in range(width)] for j in range(width)]
		
	def __getitem__(self, key):
		try:
			return self.tilemap[key[0]][key[1]]
		except:
			raise TileMapRangeException("You can't get items outside the tilemap")
		
	def __setitem__(self, key, value):
		try:
			self.tilemap[key[0]][key[1]] = value
		except:
			raise TileMapRangeException("You can't set items outside the tilemap")
		
	def __iter__(self):
		#def riter():
		for i in self.tilemap:
			for j in i:
				yield j
		#return riter
		
	def getNeighbours(self, position):
		"""
		Returns a list of the tiles surrounding the tile at position. The first
		element is the tile above it. TO BE CHANGED!
		"""
		### Get the surrounding tiles
		tiles = [self.tilemap[position[0]+i][position[1]+j]
				for i in range(-1,2) for j in range(-1,2) if i+j != 0]
		return tiles
	

class World(object):
	def __init__(self):
		self.map = TileMap(30, 30)
		
		self.industries = []
		self.industryPositions = {}
		
	def buildIndustry(self, Industry, position):
		industry = Industry(position)
		self.map[position] = industry
		### Do magic industryType => className conversion
		### Leave this to Jonex ;)
		
		### For now, hardcoded
		### Create a coal mine and update the gui
		mine = industries.CoalMine(position)
		self.industries.append(mine)
		self.industryPositions[position] = mine
		self.map[position] = mine
		self.graphics.placeNewHex(mine.position, mine.tileValue)
		
		
		
		